#include "composant.hpp"
#include "MonochromeLib.h"
#include "default.hpp"

void draw_point_fixed_camera(Point point, Camera cam){
        ML_pixel
                (
                        (cam.getFocal() * (cam.getLocation().getYp() - point.getYp()) ) / (point.getXp()) + (SCREEN_WIDTH>>1),
                        (cam.getFocal() * (cam.getLocation().getZp() - point.getZp())) / (point.getXp()) + (SCREEN_HEIGHT>>1),
                        ML_BLACK
                );
}

void draw_line_fixed_camera(Line line, Camera cam){

	int i;
	if(
		( cam.getFocal() *(cam.getLocation().getZp() - line.getPoints(0).getZp() ) ) / line.getPoints(0).getXp() < (SCREEN_HEIGHT>>1)&&
		( cam.getFocal() *(cam.getLocation().getZp() - line.getPoints(0).getZp() ) ) / line.getPoints(0).getXp() > (-SCREEN_HEIGHT>>1)&&
		( cam.getFocal() *(cam.getLocation().getYp() - line.getPoints(0).getYp() ) ) / line.getPoints(0).getXp() < (SCREEN_WIDTH>>1)&&
		( cam.getFocal() *(cam.getLocation().getYp() - line.getPoints(0).getYp() ) ) / line.getPoints(0).getXp() > (-SCREEN_WIDTH>>1)&&
		( cam.getFocal() *(cam.getLocation().getZp() - line.getPoints(1).getZp() ) ) / line.getPoints(1).getXp() < (SCREEN_HEIGHT>>1)&&
		( cam.getFocal() *(cam.getLocation().getZp() - line.getPoints(1).getZp() ) ) / line.getPoints(1).getXp() > (-SCREEN_HEIGHT>>1)&&
		( cam.getFocal() *(cam.getLocation().getYp() - line.getPoints(1).getYp() ) ) / line.getPoints(1).getXp() < (SCREEN_WIDTH>>1)&&
		( cam.getFocal() *(cam.getLocation().getYp() - line.getPoints(1).getYp() ) ) / line.getPoints(1).getXp() > (-SCREEN_WIDTH>>1)
	){
		ML_line
		(
			(cam.getFocal() * (cam.getLocation().getYp() - line.getPoints(0).getYp()) ) / (line.getPoints(0).getXp()) + (SCREEN_WIDTH>>1),
			(cam.getFocal() * (cam.getLocation().getZp() - line.getPoints(0).getZp() ) ) / (line.getPoints(0).getXp()) + (SCREEN_HEIGHT>>1),
	 		(cam.getFocal() * (cam.getLocation().getYp() - line.getPoints(1).getYp()) ) / (line.getPoints(1).getXp() ) + (SCREEN_WIDTH>>1),
			(cam.getFocal() * (cam.getLocation().getZp() - line.getPoints(1).getZp() ) ) / (line.getPoints(1).getXp()) + (SCREEN_HEIGHT>>1),
			ML_BLACK
		);
		for(i=0; i<2; i++){
			if(line.getColor() != line.getPoints(i).getColor()){
				draw_point_fixed_camera(line.getPoints(i), cam);
			}
		}
	}
}

void draw_face_fixed_camera(Face face, Camera cam)
{
        int x[3], y[3];
        int i;

        for(i=0; i<3; i++)
        {
                x[i] = (cam.getFocal() * face.getLine(i).getPoints(0).getYp()) / (face.getLine(i).getPoints(0).getZp()) + (SCREEN_WIDTH>>1);
                y[i] = (cam.getFocal() * face.getLine(i).getPoints(0).getYp()) / (face.getLine(i).getPoints(0).getZp()) + (SCREEN_HEIGHT>>1);
        }

        ML_filled_polygon(x, y, 3,ML_BLACK);

	for(i=0; i<3; i++){
		if(face.getColor() != face.getLine(i).getColor()) {
			draw_line_fixed_camera(face.getLine(i), cam);
		}
	}
}
