#include "composant.hpp"
#include "stdlib.h"

/*Vecteur Functions*/
Vecteur::Vecteur(int x, int y, int z):m_Xv(x),m_Yv(y),m_Zv(z){ //Vecteur constructor
}

void Vecteur::SetDirection(int x,int y,int z){
    m_Xv = x;
    m_Yv = y;
    m_Zv = z;
}

int Vecteur::getXv(){
    return m_Xv;
}

int Vecteur::getYv(){
    return m_Yv;
}

int Vecteur::getZv(){
    return m_Zv;
}


/*Point Functions*/
Point::Point():m_Xp(0),m_Yp(0),m_Zp(0){ //Point constructor
color=1;
}

void Point::SetLocation(int x,int y,int z){
    m_Xp = x;
    m_Yp = y;
    m_Zp = z;
}

void Point::Translate(Vecteur translation){
    m_Xp = translation.getXv();
    m_Yp = translation.getYv();
    m_Zp = translation.getZv();
}

int Point::getXp(){
    return m_Xp;
}

int Point::getYp(){
    return m_Yp;
}

int Point::getZp(){
    return m_Zp;
}

int Point::getColor(){
    return color;
}

/*Line Functions*/
Line::Line()
{
color=1;
}

Line::~Line(){
}

void Line::SetLocation(Point *points){
    tableaupoints[0]=points[0];
    tableaupoints[1]=points[1];
}

Point Line::getPoints(int a){
	return tableaupoints[a];
}

int Line::getColor(){
	return color;
}

/*Face Functions*/
Face::Face(){ //Face constructor
    line[0] = new Line();
    line[1] = new Line();
    line[2] = new Line();
    point = new Point();
}

Face::~Face(){ //Face destructor
    delete point;
    delete line[0];
    delete line[1];
    delete line[2];
}

void Face::SetComp(Line setline[2]){
    *line[0] = setline[0];
    *line[1] = setline[1];
}

Line Face::getLine(int a){
    return *line[a];
}

int Face::getColor(){
    return color;
}

/*Object Functions*/
Object::Object(){
}

Object::~Object(){
}

void Object::setNbFace(int n){
    NbFace = n;
}

/*Camera Functions*/
Camera::Camera(){
    direction = new Vecteur();
    cameraLocation = new Point();
}

Camera::~Camera(){
    delete direction;
    delete cameraLocation;
}

void Camera::SetDirection(int x, int y, int z){
    direction->SetDirection( x, y, z);
}

void Camera::SetLocation(int x, int y, int z){
    cameraLocation->SetLocation( x, y, z);
}

void Camera::setFocal(double a){
    focal = a;
}

double Camera::getFocal(){
    return focal;
}

Point Camera::getLocation(){
    return *cameraLocation;
}
