#ifndef COMPOSANT_HPP_INCLUDED
#define COMPOSANT_HPP_INCLUDED

class Vecteur{

public:
    Vecteur(int x=0, int y=0, int z=0);  //Vecteur constructor
    void SetDirection(int x,int y,int z);   //set the vector's direction
    int getXv();    //get X location
    int getYv();    //get Y location
    int getZv();    //get Z location

private:
    int m_Xv;
    int m_Yv;
    int m_Zv;
};

class Point{

public:
    Point();    //Point constructor
    void SetLocation(int x,int y,int z);    //define the point's location at (x ,y ,z)
    void Translate(Vecteur translation);    //define the point's location at (x ,y ,z)
    int getXp();    //get X location
    int getYp();    //get Y location
    int getZp();    //get Z location
    int getColor();

private:
    int m_Xp;
    int m_Yp;
    int m_Zp;
    int color;
};

class Line{

public:
    Line();
    ~Line();
    void SetLocation(Point points[2]);
    Point getPoints(int a);
    int getColor();

private:
    Point tableaupoints[2];
    int color;
};

class Face{

public:
    Face(); //Face constructor
    ~Face();    //Face destructor
    void SetComp(Line setline[2]); //set the face with 2 vector
    Line getLine(int a);
    int getColor();

private:
    Point* point;
    Line* line[3];
    int color;
};

class Object{
public:
    Object();
    ~Object();
    void setNbFace(int n);

private:
    int NbFace;
};

class Camera{

public:
    Camera();
    ~Camera();
    void SetLocation(int xp, int yp, int zp);
    void SetDirection(int xv, int yv, int zv);
    void setFocal(double a);
    double getFocal();
    Point getLocation();
    void MoveTranslation(Vecteur vec);

private:
    double focal;
    Point* cameraLocation;
    Vecteur* direction;

};

#endif // COMPOSANT_HPP_INCLUDED
